package LMS.frontend;

import java.util.*;
import java.net.*;
import java.io.*;

import webflow.backend.*;


public class wmsWrapper extends Object {
  

  lmsFrame frame;
  private SMreply _smreply;
  private SMreply _connect;
  String hostName; 
  String ClientID;
  int portNumber;
  String smURL;
  ClientSocket socket; 

  int port;
  DataOutputStream dos;
  DataInputStream dis;
  boolean connected;
  boolean completed;


  public wmsWrapper(lmsFrame frame) {

this.frame=frame;

 /* initialize backend */

hostName = frame.hostName;
portNumber  = frame.portNumber;
ClientID = frame.ClientID;
smURL = frame.SM_URL;

System.err.println("smURL="+smURL);

      _smreply=requestInit("LMS.backend.runWMS",hostName);
      if(_smreply != null) {
           System.err.println("received reply from requestInit"); 
      }
      else {
           System.err.println("SOMETHING WENT WRONG !!!!!!!!!!!!!!");
      }

/* this will be needed to connect modules 
      Vector tmpPortList = _smreply.getPortList();
      int tmpListLenght = tmpPortList.size();
*/

      SMreply runnit=runModules();

      System.err.println("backend started!");    

      /* now make a socket connection */

      new connector(this,hostName);


//  no user inteface but wait for sygnal to kill the backend


    waitUntilSocketReady();   

    String message=socket.receive();
    System.err.println("I have received message "+message); 
    destroyAll();
}

  public synchronized void waitUntilSocketReady() { 
     
      try{
         wait(1000);
      } catch(Exception e) {
         System.err.println("problem with waiting? "+e.toString());
      }

  }

  // adopted from WebEeditor

  /**
  * <ol>
  *  <li> Open an Url connection to the SessionManager Object
  *  <li> Tell her your ClientId, new_module request and the name of the module.
  *  <li> Wait its response.
  *  <li> If the first word of first line is OK, this means that 
  *       she got the message and everything is ok. Then read the
  *       port number from the second line to read the result of the
  *       operation.
  * </ol>
  *
  */

  SMreply requestFromServer(String request) {

    SMreply reply = null;
    int current_portNumber = -1;

    if(request==null) return null;

    try
    {
      System.err.println("start requestFromServer");
      //Added by Erol for chache problem
      Date dt = new Date ();
      String tmp = Long.toString(dt.getTime());
      request = request+"&time="+tmp;
      System.err.println("request: "+request);
           
      URL myReq = new URL(request);
      
      try
      {
        DataInputStream dis = new DataInputStream( myReq.openStream() );
        
        String status = dis.readLine();
        StringTokenizer STstatus = new StringTokenizer(status);
        
   System.err.println(" I read status :"+status);

        if( STstatus.countTokens() > 0 &&  
            STstatus.nextElement().equals("OK")  )
        {
          String SportNumber = dis.readLine();
          System.err.println(" I read SportNumber:"+SportNumber);
          
          current_portNumber = Integer.parseInt(SportNumber); 

        } else return reply;

      } catch ( IOException e)
        {
           System.err.println("IOException is raised!");
           e.printStackTrace();
           return reply;
        }

    } catch ( MalformedURLException mue)
      {
        System.err.println(" MalformedURLException is raised!");
        mue.printStackTrace();
        return reply;
      } 
 
    /** If port number is invalid exit */
    if( current_portNumber < 1 ) return reply;

    System.err.println("port number seems to be OK");

    Socket Csocket = null;
    DataInputStream  Cdin  = null;
    DataOutputStream Cdout = null;

    try
    {
      Csocket = new Socket(hostName, current_portNumber );

      Cdin = new DataInputStream( Csocket.getInputStream() );

      Cdout = new DataOutputStream( Csocket.getOutputStream() );

    } catch( UnknownHostException e)
      {
         System.err.println("UnknownHostException" + e +" raised!");
         e.printStackTrace(); 
         return reply;
      }
      catch( IOException e)
      {
         System.err.println("IOException (2)" + e + " raised!");
         e.printStackTrace(); 
         return reply;
      }
       
    System.err.println("create empty reply");   
    reply = new SMreply();
    System.err.println("created empty reply");   

    try
    {
      reply.fromStream(Cdin);
      System.err.println("got reply?"); 
      System.err.println("reply? "+reply.getStatus()+" x");

      if(reply.getStatus() == SMreply.ERROR) 
       	System.err.println( reply.getDescription());

    } catch( NullPointerException e)
      {
         System.err.println("NullPointerException vo requestInit" + e);
         e.printStackTrace();
         return null;
      }

    System.err.println("ready to return from requestFromServer");
    return reply;

  }// end of requestFromServer()

  /**
  * Initialize the module
  */
  public SMreply 
  requestInit(String moduleClassName, String moduleHost)
  //  requestInit(ModuleTreeItem m)
  { 
     String myreq = new String(smURL+"?cmd=new_module&ClientID="+
                               ClientID+"&name="+moduleClassName);

     System.err.println("req(InitModule):"+ myreq);

/*
     ntotal++;
     if(ntotal>10) {System.out.println("too many modules!!!!!!!!!!!!!!!");}
     int lastdot = moduleClassName.lastIndexOf(".")+1;
     String mname = moduleClassName.substring(lastdot);
     System.out.println("---> HASH of "+mname);
     Integer r1 = (Integer)FEclasses.ModuleNames.get(mname);
     System.out.println("R1: "+r1+" of "+ntotal);
     
     if(r1 != null) {
         int r2 = r1.intValue();
         am.addNewModule(ntotal,r2,mname,moduleHost);
     }
     else {
        am.addNewModule(ntotal,0,mname,moduleHost);
     }

     System.out.println("End of requestInit ");
 */

     return requestFromServer(myreq); 

  }// end of requestInit()


  /**
  */
  public SMreply
  connect(ID from, ID to, ID fromModule, ID toModule )
  {
    String req = new String(smURL+"?cmd=connect&ClientID="+ClientID);
    req += "&fromStr="+from.getString();
    req += "&fromVal="+from.getInt();
    req += "&toStr="+to.getString();
    req += "&toVal="+to.getInt();
    req += "&mIDfromStr="+fromModule.getString();
    req += "&mIDfromVal="+fromModule.getInt();
    req += "&mIDtoStr="+toModule.getString();
    req += "&mIDtoVal="+toModule.getInt();

    return requestFromServer( req );

  }// end of connect()

  /**
  * Runs all the modules in the current session
  */
  public SMreply
  runModules()
  {
     String req = new String(smURL+"?cmd=run_modules&ClientID="+ClientID);
     System.err.println("runRequest="+req);
     return requestFromServer(req);

  }// end of run()

  /**
  * public version of SMreply destroy that is void (TH)
  */

  public void destroyAll() {
  _smreply = destroy();
  }    

  /**
  * Destroys all the modules in the current session
  */
  public SMreply
  destroy()
  {
    //    am.clean();
    //    ntotal=0;
    

     String req = new String(smURL+"?cmd=destroy_modules&ClientID="+ClientID);

     SMreply rett= requestFromServer(req);

     if( rett == null ) 
         rett = new SMreply(SMreply.ERROR,"Unkown");

     return rett ;

  }// end of destroy()

  public void setValue(String s) {
  System.out.println("setValue: "+s); 
  if(socket != null) {
        socket.send(s);
  }
  else {
        System.err.println("setValue failed!!!! - no socket available");
  }
  } 

  public void ConnectIt(String host, String msg) {
       System.out.println("ConnectIt to "+host);
       // first ask PortServer for the Port
       // you may wait for it till the module registers it

       int ntry=0;
       port = 0;
       while(port==0 & ntry<25) { 

       ntry++;
       // send request GET
       System.out.println("send request GET ("+ntry+")");

    try {
      Socket PSsocket = new Socket(host,5500);
      dos= new DataOutputStream(PSsocket.getOutputStream());
      dis= new DataInputStream(PSsocket.getInputStream());
      } catch(IOException e) {System.out.println(e.toString());}
    
      // String msg = "GET";  now it is an input argument
        int sl = msg.length();
        byte[] buf =new byte[sl];
        msg.getBytes(0,sl,buf,0); 
        System.out.println("Trying to send... "+msg);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e+" while sending GET");}

	  // get replay

        String replay = "";
        try{
           int ls=dis.readInt();
           byte buf1[] = new byte[ls];
           dis.read(buf1,0,ls);
           replay = new String(buf1,0,ls);
           System.out.println("I have received from PortServer: "+replay);
        } catch(IOException e){
          System.out.println(e+" while getting replay");
	  if(socket!=null) {socket.stop();}       //  stop();
        }
        Integer iport = new Integer(replay);
        port = iport.intValue();
      } // end of while look
 

       if(port != 0) {
         System.out.println("Try to connect to port :"+port+" at "+hostName);
         socket = new ClientSocket(this,hostName,port);
         connected=true;
       }
       else {
         System.out.println("Connection failed!");
       }
  } 



}

class connector implements Runnable {

  String localhost;
  String host;
  String remotehost;  

  private Thread runner;
  wmsWrapper c;

  connector(wmsWrapper c, String host){
  this.c=c;
  this.host = host;
  remotehost = null;
  start();
  }

  connector(wmsWrapper c, String host, String remotehost){
  this.c=c;
  this.host = host;
  this.remotehost = remotehost;
  System.err.println("connector: connect to a remote host");
  start();
  }

  public void run(){ 
    if(remotehost != null) {
      c.ConnectIt(remotehost,"RGT"+host);  //Remote GeT
    }
    else {
      c.ConnectIt(host,"GET");
    }

    /* must be moved to run method because it won't work for remote modules
       since GET returns before PUT is issued
      try {
        InetAddress local = java.net.InetAddress.getLocalHost();
        localhost = local.getHostName();
        System.out.println("HOST: "+localhost);
       } catch(UnknownHostException e) {System.out.println(e);}
         catch(IOException e) {System.out.println(e);}
 
     c.setValue("DISP"+localhost);
     */
  }

  public void start(){
  if(runner==null){
      runner=new Thread(this);
      runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }


}

